﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;
using Microsoft.EntityFrameworkCore.ChangeTracking.Internal;

namespace Dardabahn_WPF.Controller
{
    internal class AutoController
    {
        internal DardabahnContext ctx;

        public AutoController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }

        public void Create(Auto a)
        {
            try
            {
                ctx.Autos.Add(a);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public List<Auto> ReadAll()
        {
            try
            {
                return ctx.Autos.ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }
        }

        public List<Auto> ReadByTeamID(int id)
        {
            try
            {
                return ctx.Autos.Where(x => x.TeamId == id).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }
        }
        public List<ShortAuto> ReadByTeamIDkurz(int id)
        {
            try
            {
                return ctx.Autos.Select(A => new ShortAuto() {AutoId = A.AutoId, Farbe = A.Farbe, TeamId = A.TeamId }).Where(A => A.TeamId == id).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }
        }
        public void Update(Auto a)
        {
            try
            {
                Auto AutotoUpdate = ctx.Autos.FirstOrDefault(A => A.AutoId == a.AutoId);
                AutotoUpdate.Farbe = a.Farbe;
                ctx.Autos.Update(AutotoUpdate);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        public void Delete(Auto a)
        {
            try
            {
                Auto AutotoRemove = ctx.Autos.FirstOrDefault(A => A.AutoId == a.AutoId);
                ctx.Autos.Remove(AutotoRemove);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }
    }
}
