﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;

namespace Dardabahn_WPF.Controller
{
    internal class MitgliedController
    {
        internal DardabahnContext ctx;

        public MitgliedController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }
        public void Create(Mitglied m)
        {
            try
            {
                ctx.Mitglieds.Add(m);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        public List<Mitglied> ReadAll()
        {
            try
            {
                return ctx.Mitglieds.ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }
        public List<Mitglied> ReadByTeamID(int id)
        {
            try
            {
                return ctx.Mitglieds.Where(x => x.TeamId == id).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }
        public List<ShortMitglied> ReadByTeamIDkurz(int id)
        {
            try
            {
                return ctx.Mitglieds.Select(M => new ShortMitglied() { MitgliedId = M.MitgliedId, Vorname = M.Vorname, Nachname = M.Nachname, Alter = M.Alter, TeamId = M.TeamId }).Where(M => M.TeamId == id).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public void Update(Mitglied m)
        {
            try
            {
                Mitglied mitgliedToUpdate = ctx.Mitglieds.FirstOrDefault(M => M.MitgliedId == m.MitgliedId);
                if (mitgliedToUpdate != null)
                {
                    mitgliedToUpdate.Vorname = m.Vorname;
                    mitgliedToUpdate.Nachname = m.Nachname;
                    mitgliedToUpdate.Alter = m.Alter;
                    ctx.Mitglieds.Update(mitgliedToUpdate);
                    ctx.SaveChanges();
                }
                else
                {
                    MessageBox.Show("Mitglied nicht gefunden.");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void Delete(Mitglied m)
        {
            try
            {
                Mitglied mitgliedToDelete = ctx.Mitglieds.FirstOrDefault(M => M.MitgliedId == m.MitgliedId);
                if (mitgliedToDelete != null)
                {
                    ctx.Mitglieds.Remove(mitgliedToDelete);
                    ctx.SaveChanges();
                }
                else
                {
                    MessageBox.Show("Mitglied nicht gefunden.");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

    }
}
