﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;
using Microsoft.EntityFrameworkCore;

namespace Dardabahn_WPF.Controller
{
    internal class RennenController
    {
        internal DardabahnContext ctx;

        public RennenController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }

        public List<RennenAnzeige> ReadAllAnzeigebyVeranstaltung(int Veranstaltungsid)
        {
            // Rennen (enthält FK) und Teilnahme (enthält PK) joinen
            try
            {
                var res = ctx.Teilnahmes
                    .Join(ctx.Rennens
                        , teilnahme => teilnahme.TeilnahmeId
                        , rennen => rennen.TeilnahmeId
                        , (teilnahme, rennen) => new RennenAnzeige() { RennenId = rennen.RennenId, Startzeit = rennen.Startzeit, Endzeit = rennen.Endzeit, Rundenzeit = rennen.Endzeit - rennen.Startzeit, Szenarien = rennen.Szenarien, TeilnahmeId = teilnahme.TeilnahmeId, TeamId = teilnahme.TeamId,VeranstaltungsId = teilnahme.VeranstaltungsId}).Where(x=> x.VeranstaltungsId == Veranstaltungsid).ToList();

                return res;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }
        }
    }

}
