﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;

namespace Dardabahn_WPF.Controller
{
    internal class RennstreckeController
    {
        internal DardabahnContext ctx;

        public RennstreckeController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }
        public List<Rennstrecke> ReadAll()
        {
            try
            {
                return ctx.Rennstreckes.ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public List<ShortRennstrecke> ReadbyTeamIDkurz(int id)
        {
            try
            {
                return ctx.Rennstreckes.Select(r => new ShortRennstrecke() {RennstreckenId = r.RennstreckenId, TeamId = r.TeamId }).Where(R => R.TeamId == id).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }
        public void Create(Rennstrecke r)
        {
            try
            {
                ctx.Rennstreckes.Add(r);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        public void Delete(Rennstrecke r)
        {
            try
            {
                Rennstrecke RennstrecketoRemove = ctx.Rennstreckes.Where(R => R.RennstreckenId == r.RennstreckenId).FirstOrDefault();
                ctx.Rennstreckes.Remove(RennstrecketoRemove);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }
    }
}
