﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;

namespace Dardabahn_WPF.Controller
{
    internal class TeamController
    {
        internal DardabahnContext ctx;

        public TeamController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }

        public void Create(Team t)
        {
            try
            {
                ctx.Teams.Add(t);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        public List<Team> ReadAll()
        {
            try
            {
                return ctx.Teams.ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public List<ShortTeam> ReadAllkurz()
        {
            try
            {
                return ctx.Teams.Select(T => new ShortTeam() { TeamId = T.TeamId, Name = T.Name }).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public Team ReadByName(string name)
        {
            try
            {
                return ctx.Teams.Where(x => x.Name == name).FirstOrDefault();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public void Update(Team T)
        {
            try
            {
                Team TeamToUpdate = ctx.Teams.FirstOrDefault(t => t.TeamId == T.TeamId);
                if (TeamToUpdate != null)
                {
                    TeamToUpdate.Name = T.Name;
                    ctx.Teams.Update(TeamToUpdate);
                    ctx.SaveChanges();
                }
                else
                {
                    MessageBox.Show("Team nicht gefunden.");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void Delete(Team T)
        {
            try
            {
                Team teamToDelete = ctx.Teams.FirstOrDefault(t => t.TeamId == T.TeamId);
                if (teamToDelete != null)
                {
                    ctx.Teams.Remove(teamToDelete);
                    ctx.SaveChanges();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }



    }
}
