﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;
using Microsoft.EntityFrameworkCore;

namespace Dardabahn_WPF.Controller
{
    internal class TeilnahmeController
    {
        internal DardabahnContext ctx;

        public TeilnahmeController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }

        public void Create(Teilnahme T)
        {
            try
            {
                ctx.Teilnahmes.Add(T);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public List<ShortTeilnahme> ReadAllkurz()
        {
            try
            {
                return ctx.Teilnahmes.Select(t => new ShortTeilnahme() { TeilnahmeId = t.TeilnahmeId, VeranstaltungsId = t.VeranstaltungsId, Datum = t.Datum, TeamId = t.TeamId }).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }

        public List<NoTeilnahmeklasse> ReadAllNoTeilnahme(int VeranstaltungId)
        {
            try
            {
                return ctx.Teams
                    .FromSqlRaw($"SELECT t.Team_ID,t.Name,tn.Teilnahme_ID FROM team t JOIN teilnahme tn ON t.Team_ID = tn.Team_ID LEFT JOIN rennen r ON tn.Teilnahme_ID = r.Teilnahme_ID WHERE tn.Veranstaltungs_ID = {VeranstaltungId} AND r.Rennen_ID IS NULL")
                    .Select(t => new NoTeilnahmeklasse { TeamId = t.TeamId,Name = t.Name})
                    .ToList();

            }
            catch {
                MessageBox.Show("Fehler beim Lesen der NoTeilnahme!");
                return null;
            }
        }
        public void Update(Teilnahme T)
        {
            try
            {
                Teilnahme TeilnahmetoUpdate = ctx.Teilnahmes.Where(t => t.TeilnahmeId == T.TeilnahmeId).FirstOrDefault();
                TeilnahmetoUpdate.VeranstaltungsId = T.VeranstaltungsId;
                TeilnahmetoUpdate.Datum = DateTime.Now;
                TeilnahmetoUpdate.TeamId = T.TeamId;
                ctx.Teilnahmes.Update(TeilnahmetoUpdate);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void Delete(Teilnahme T)
        {
            try
            {
                Teilnahme TeilnahmetoDelete = ctx.Teilnahmes.Where(t => t.TeilnahmeId == T.TeilnahmeId).FirstOrDefault();
                ctx.Teilnahmes.Remove(TeilnahmetoDelete);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }


    }
}
