﻿using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dardabahn_WPF.Models;
using System.Windows;

namespace Dardabahn_WPF.Controller
{
    internal class VeranstaltungController
    {
        internal DardabahnContext ctx;

        public VeranstaltungController(DardabahnContext ctx)
        {
            this.ctx = ctx;
        }

        public void Create(Veranstaltung v)
        {
            try
            {
                ctx.Veranstaltungs.Add(v);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        public List<Veranstaltung> ReadAll()
        {
            try
            {
                return ctx.Veranstaltungs.ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }
        public List<ShortVeranstaltung> ReadAllkurz()
        {
            try
            {
                return ctx.Veranstaltungs.Select(v => new ShortVeranstaltung() {VeranstaltungsId = v.VeranstaltungsId, RennstreckenId = v.RennstreckenId}).ToList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return null;
            }

        }


        public void Update(Veranstaltung v)
        {
            try
            {
                Veranstaltung VeranstaltungtoUpdate = ctx.Veranstaltungs.Where(V => V.VeranstaltungsId == v.VeranstaltungsId).FirstOrDefault();
                VeranstaltungtoUpdate.RennstreckenId = v.RennstreckenId;
                ctx.Veranstaltungs.Update(VeranstaltungtoUpdate);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        public void Delete(Veranstaltung v)
        {
            try
            {
                Veranstaltung VeranstaltungtoDelete = ctx.Veranstaltungs.Where(V => V.VeranstaltungsId == v.VeranstaltungsId).FirstOrDefault();
                ctx.Veranstaltungs.Remove(VeranstaltungtoDelete);
                ctx.SaveChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
