﻿using Dardabahn_WPF.Controller;
using Dardabahn_WPF.Models;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Dardabahn_WPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        IO_Controller ioc;
        Team_Fenster TeamAuswahl = null;
        Veranstaltung_Fenster VeranstaltungVerwaltung = null;
        Rennen_Fenster RennenAuswertung = null;
        
        public MainWindow()
        {
            InitializeComponent();
            ioc = new IO_Controller();
            UpdateData();
        }
        // Ich musste meine Delete und Update Methode anpassen in den Controllern da die DardabahnContext aus welchen gründen auch immer 2 instanzen zeitgleich getrackt hat obwohl es nichtmal 2 instanzen gibt :/
        // Auf ihren Wunsch hin ist alles was von Philipp gemacht wurde nochmal Extra makiert und der rest ist von mir Leon :)
        // DIE KOMPLETTE NoTeilnahme und alles zugehörige wurden von Philipp gemacht :)
        private void Button_Create_Team_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Teams.SelectedItem != null)
                {
                    ShortTeam t = DataGrid_Teams.SelectedItem as ShortTeam;
                    Team T = new Team(0, t.Name);
                    ioc.tc.Create(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Team ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void Button_Update_Team_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Teams.SelectedItem != null)
                {
                    ShortTeam t = DataGrid_Teams.SelectedItem as ShortTeam;
                    Team T = new Team(t.TeamId, t.Name);
                    ioc.tc.Update(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Team ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void Button_Delete_Team_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Teams.SelectedItem != null)
                {
                    ShortTeam t = DataGrid_Teams.SelectedItem as ShortTeam;
                    Team T = new Team(t.TeamId, t.Name);
                    ioc.tc.Delete(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Team ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }
        private void Button_Team_auswahl_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Team T = ioc.tc.ReadByName(ComboBox_Teams.SelectedItem as string);
                if (TeamAuswahl == null)
                {
                    TeamAuswahl = new Team_Fenster(ioc, T);
                    TeamAuswahl.Show();
                }
                else
                {
                    TeamAuswahl.Close();
                    TeamAuswahl = new Team_Fenster(ioc, T);
                    TeamAuswahl.Show();
                }

            }
            catch (Exception ex) 
            {
                MessageBox.Show(ex.Message);
            }

        }


        private void Button_Veranstaltung_Verwalten_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (VeranstaltungVerwaltung == null)
                {
                    VeranstaltungVerwaltung = new Veranstaltung_Fenster(ioc);
                    VeranstaltungVerwaltung.Show();
                }
                else
                {
                    VeranstaltungVerwaltung.Close();
                    VeranstaltungVerwaltung = new Veranstaltung_Fenster(ioc);
                    VeranstaltungVerwaltung.Show();
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        private void Button_Auswertung_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                string tmp = ComboBox_Veranstaltungen_Rennauswertung.SelectedItem as string;
                int VeranstaltungsID = 0;
                if (!string.IsNullOrEmpty(tmp))
                {
                    foreach (char x in tmp)
                    {
                        if (int.TryParse(x.ToString(), out int z)) { VeranstaltungsID = z; }
                    }
                    if (RennenAuswertung == null)
                    {
                        RennenAuswertung = new Rennen_Fenster(ioc,VeranstaltungsID);
                        RennenAuswertung.Show();
                    }
                    else
                    {
                        RennenAuswertung.Close();
                        RennenAuswertung = new Rennen_Fenster(ioc,VeranstaltungsID);
                        RennenAuswertung.Show();
                    }
                }
                else
                {
                    MessageBox.Show("Bitte Wähle eine Veranstaltung aus!");
                }


            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        private void Button_Refresh_Click(object sender, RoutedEventArgs e)
        {
            UpdateData();
        }
        public void UpdateData()
        {
            try
            {
                DataGrid_Teams.ItemsSource = null;
                ComboBox_Teams.Items.Clear();
                ComboBox_Veranstaltungen_Rennauswertung.Items.Clear();

                foreach (Veranstaltung v in ioc.vc.ReadAll())
                {
                    ComboBox_Veranstaltungen_Rennauswertung.Items.Add($"Die {v.VeranstaltungsId.ToString()} Veranstaltung");
                }

                foreach (Team t in ioc.tc.ReadAll())
                {
                    ComboBox_Teams.Items.Add(t.Name.ToString());
                }
                DataGrid_Teams.ItemsSource = ioc.tc.ReadAllkurz();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }


        }


    }
}