﻿using Dardabahn_WPF.Controller;
using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Dardabahn_WPF
{
    /// <summary>
    /// Interaktionslogik für Team_Fenster.xaml
    /// </summary>
    public partial class Team_Fenster : Window
    {
        IO_Controller ioc;
        Team SelectedTeam;
        public Team_Fenster(IO_Controller ioc, Team SelectedTeam)
        {
            InitializeComponent();
            this.ioc = ioc;
            this.SelectedTeam = SelectedTeam;
            UpdateData();
        }

        private void Button_Create_Mitglied_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Mitglieder.SelectedItem != null)
                {
                    ShortMitglied m = DataGrid_Mitglieder.SelectedItem as ShortMitglied;
                    Mitglied M = new Mitglied(0, m.Vorname, m.Nachname, m.Alter, SelectedTeam.TeamId);
                    ioc.mc.Create(M);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Mitglied ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Delete_Mitglied_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Mitglieder.SelectedItem != null)
                {
                    ShortMitglied m = DataGrid_Mitglieder.SelectedItem as ShortMitglied;
                    Mitglied M = new Mitglied(m.MitgliedId, m.Vorname, m.Nachname, m.Alter, SelectedTeam.TeamId);
                    ioc.mc.Delete(M);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Mitglied ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Update_Mitglied_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Mitglieder.SelectedItem != null)
                {
                    ShortMitglied m = DataGrid_Mitglieder.SelectedItem as ShortMitglied;
                    Mitglied M = new Mitglied(m.MitgliedId, m.Vorname, m.Nachname, m.Alter, SelectedTeam.TeamId);
                    ioc.mc.Update(M);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Mitglied ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Create_Auto_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Autos.SelectedItem != null)
                {
                    ShortAuto a = DataGrid_Autos.SelectedItem as ShortAuto;
                    Auto A = new Auto(0, a.Farbe, SelectedTeam.TeamId);
                    ioc.ac.Update(A);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Auto ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Delete_Auto_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                if (DataGrid_Autos.SelectedItem != null)
                {
                    ShortAuto a = DataGrid_Autos.SelectedItem as ShortAuto;
                    Auto A = new Auto(a.AutoId, a.Farbe, SelectedTeam.TeamId);
                    ioc.ac.Delete(A);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Auto ausgewählt!");
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Update_Auto_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Autos.SelectedItem != null)
                {
                    ShortAuto a = DataGrid_Autos.SelectedItem as ShortAuto;
                    Auto A = new Auto(a.AutoId, a.Farbe, SelectedTeam.TeamId);
                    ioc.ac.Update(A);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast kein Auto ausgewählt!");
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        private void Button_Create_Rennstrecke_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Rennstrecken.SelectedItem != null)
                {
                    ShortRennstrecke r = DataGrid_Rennstrecken.SelectedItem as ShortRennstrecke;
                    Rennstrecke R = new Rennstrecke(0,SelectedTeam.TeamId);
                    ioc.rsc.Create(R);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Rennstrecke ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Delete_Rennstrecke_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Rennstrecken.SelectedItem != null)
                {
                    ShortRennstrecke r = DataGrid_Rennstrecken.SelectedItem as ShortRennstrecke;
                    Rennstrecke R = new Rennstrecke(r.RennstreckenId, SelectedTeam.TeamId);
                    ioc.rsc.Delete(R);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Rennstrecke ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void UpdateData()
        {
            try
            {
                DataGrid_Mitglieder.ItemsSource = null;
                DataGrid_Autos.ItemsSource = null;
                DataGrid_Rennstrecken.ItemsSource = null;

                DataGrid_Mitglieder.ItemsSource = ioc.mc.ReadByTeamIDkurz(SelectedTeam.TeamId);
                DataGrid_Autos.ItemsSource = ioc.ac.ReadByTeamIDkurz(SelectedTeam.TeamId);
                DataGrid_Rennstrecken.ItemsSource = ioc.rsc.ReadbyTeamIDkurz(SelectedTeam.TeamId);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }


        }
    }
}
