﻿using Dardabahn_WPF.Controller;
using Dardabahn_WPF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Dardabahn_WPF
{
    /// <summary>
    /// Interaktionslogik für Veranstaltung_Fenster.xaml
    /// </summary>
    public partial class Veranstaltung_Fenster : Window
    {
        IO_Controller ioc;
        public Veranstaltung_Fenster(IO_Controller ioc)
        {
            InitializeComponent();
            this.ioc = ioc;
            UpdateData();
        }
        private void Button_Create_Veranstaltung_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Veranstaltung.SelectedItem != null)
                {
                    ShortVeranstaltung v = DataGrid_Veranstaltung.SelectedItem as ShortVeranstaltung;
                    Veranstaltung V = new Veranstaltung() { VeranstaltungsId = 0, RennstreckenId = v.RennstreckenId};
                    ioc.vc.Create(V);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Update_Veranstaltung_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Veranstaltung.SelectedItem != null)
                {
                    ShortVeranstaltung v = DataGrid_Veranstaltung.SelectedItem as ShortVeranstaltung;
                    Veranstaltung V = new Veranstaltung() { VeranstaltungsId = v.VeranstaltungsId, RennstreckenId = v.RennstreckenId };
                    ioc.vc.Update(V);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        private void Button_Delete_Veranstaltung_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Veranstaltung.SelectedItem != null)
                {
                    ShortVeranstaltung v = DataGrid_Veranstaltung.SelectedItem as ShortVeranstaltung;
                    Veranstaltung V = new Veranstaltung() { VeranstaltungsId = v.VeranstaltungsId, RennstreckenId = v.RennstreckenId };
                    ioc.vc.Delete(V);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        private void Button_Create_Teilnahme_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Teilnahme.SelectedItem != null)
                {
                    ShortTeilnahme t = DataGrid_Teilnahme.SelectedItem as ShortTeilnahme;
                    Teilnahme T = new Teilnahme() {TeilnahmeId = 0, Datum = DateTime.Now, VeranstaltungsId = t.VeranstaltungsId, TeamId = t.TeamId };
                    ioc.tec.Create(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Update_Teilnahme_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Teilnahme.SelectedItem != null)
                {
                    ShortTeilnahme t = DataGrid_Teilnahme.SelectedItem as ShortTeilnahme;
                    Teilnahme T = new Teilnahme() { TeilnahmeId = t.TeilnahmeId, Datum = DateTime.Now, VeranstaltungsId = t.VeranstaltungsId, TeamId = t.TeamId };
                    ioc.tec.Update(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Button_Delete_Teilnahme_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (DataGrid_Teilnahme.SelectedItem != null)
                {
                    ShortTeilnahme t = DataGrid_Teilnahme.SelectedItem as ShortTeilnahme;
                    Teilnahme T = new Teilnahme() { TeilnahmeId = t.TeilnahmeId, Datum = DateTime.Now, VeranstaltungsId = t.VeranstaltungsId, TeamId = t.TeamId };
                    ioc.tec.Delete(T);
                    UpdateData();
                }
                else
                {
                    MessageBox.Show("Du hast keine Teilnahme ausgewählt!");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void UpdateData()
        {
            try
            {
                DataGrid_Veranstaltung.ItemsSource = null;
                DataGrid_Teilnahme.ItemsSource = null;

                DataGrid_Veranstaltung.ItemsSource = ioc.vc.ReadAllkurz();
                DataGrid_Teilnahme.ItemsSource = ioc.tec.ReadAllkurz();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }


    }
}
