from luma.core.interface.serial import i2c
from luma.oled.device import ssd1306
from PIL import Image, ImageDraw, ImageFont

# OLED-Display-Initialisierung
serial = i2c(port=1, address=0x3C)
device = ssd1306(serial, width=128, height=64)

# Schriftarten laden
font_path = "/usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf"
font = ImageFont.truetype(font_path, size=40)  # Standardgröße
small_font = ImageFont.truetype(font_path, size=30)  # Kleine Schriftgröße

def update_oled_display(message, small=False):
    # Erstelle ein neues Bild
    image = Image.new("1", (128, 64))
    draw = ImageDraw.Draw(image)

    # Wähle Schriftgröße
    selected_font = small_font if small else font

    # Berechne Textgröße
    text_width = draw.textlength(message, font=selected_font)
    text_height = selected_font.getbbox(message)[3]

    # Berechne Position für zentrierten Text
    x = (128 - text_width) // 2
    y = (64 - text_height) // 2

    # Text zeichnen
    draw.text((x, y), message, font=selected_font, fill=255)

    # Bild auf OLED anzeigen
    device.display(image)
